
'---------------------------------------------------------------------------
' Pushem was made by Danny Albocher. Feel free to do whatever you want
' with it... but if you like it, or dislike it, tell me.
' if you want a few more levels and too tired to make your own, i'd be
' happy to send you some.
' my Email addres
' danyal@netvision.net.il  feel free to do whatever you want with it...
'---------------------------------------------------------------------------
' Objective:
' You are supposed to push the green boxes to the green circle things, that
' are supposed to be targets. What stops you are the walls (blue boxes) that
' are NOT moveable, and the red boxes, that ARE moveable. Anyway you can't
' move more than one block at a time when they are in a row.
' You can only push the blocks, wich meens that if you got a green box in a
' corner, it will be stuck there forever (or until you swich to build mode).
' Note that it is very important which block you put in place first. In some
' levels, you might block your way accidently.
' When you think you have finished the level, press SPACE-BAR to move on to
' the next one. currently there are only 5 levels, ordered from easy to hard.
'                               Good luck.
'---------------------------------------------------------------------------
' Build mode:
' When you switch to build mode, you will be able to move ON moveable and
' unmovable blocks. Pressing SPACE-BAR will build a new box. Pressing again
' will change the box type and color; (Blue - wall, Green - Blocks to move,
' Cyan - future to be target. To make it a target you'll have to save the
' level ("s"), and load it ("l"). There are also the red blocks which are
' used just to block the way, they are moveable on game mode.
' Every map in normal size (20X20) is about 2K, so you don't have to worry
' about that.
' If you make your own levels and want them to be in the game when you run it
' without having to load them every time. Just add them to the DATA line on
' the bottom of this screen. Just don't forget that the last string needs to
' be "end", or there will be problems.
'---------------------------------------------------------------------------



' If you had trouble understanding something PLEASE Email me, i'd love to help.



DECLARE SUB showboard2 () 'shows the whole board. uses showboard.
DECLARE SUB showboard (startx!, starty!, endx!, endy!) ' shows part of the board
DECLARE SUB saveboard (a$) 'saves the board
DECLARE SUB optionmenu () ' shows the options menu on the screen
DECLARE SUB initboard (a$) ' loads a level from drive to memory
DECLARE SUB check () ' checks if you won, or you just BLUFFING.
DECLARE SUB refresh () ' draws targets again, just in case you've run them over
DECLARE SUB addlist (xcor!, ycor!) ' adds a target to the target list
DECLARE SUB moveme (x!, y!, a$) ' moves blocks if possible
SCREEN 12
ON ERROR GOTO errorcontrol

' information about the board (playing with winwidth, and winlength is cute).
CONST brdwidth = 20, brdlength = 20, winwidth = 400, winlength = 400
CONST boxw = winwidth / brdwidth, boxl = winlength / brdlength

build = 0 ' build mode starts OFF

DIM SHARED board(brdwidth + 1, brdlength + 1)
DIM SHARED endlist(20, 2)

' start first level:
READ c$
initboard (c$)

' Main part:
start:
    a$ = INKEY$
    IF TIME$ <> rectime$ THEN rectime$ = TIME$: seconds = seconds + 1
    IF a$ = "" THEN GOTO start
'Options
   
    IF a$ = CHR$(156) THEN
        build = NOT (build)
        LOCATE 22, winwidth / 8 + 5
        IF build THEN
            PRINT "Build mode"
        ELSE
            PRINT "Game mode "
        END IF
    END IF
    IF build THEN
        IF a$ = " " THEN board(xcor, ycor) = (board(xcor, ycor) + 1) MOD 5: CALL showboard(xcor, ycor, xcor, ycor)
        IF a$ = "n" THEN
            READ c$
            IF c$ = "end" THEN RESTORE: READ c$
            CALL initboard(c$)
        END IF
    ELSEIF a$ = " " THEN
        CALL check
        a$ = ""
    END IF
   
    IF a$ = "s" THEN CALL saveboard("")
    IF a$ = "l" THEN CALL initboard("")
    IF a$ = "r" THEN CALL initboard(c$)
    IF a$ = "e" THEN END
'moving  
    IF board(xcor, ycor) = 0 THEN CIRCLE (xcor * boxw + boxw / 2, ycor * boxl + boxl / 2), boxw / 3, a
    CIRCLE (xcor * boxw + boxw / 2, ycor * boxl + boxl / 2), boxw / 3 - 2, a
    txcor = txcor - (a$ = CHR$(0) + "M") + (a$ = CHR$(0) + "K")
    tycor = tycor - (a$ = CHR$(0) + "P") + (a$ = CHR$(0) + "H")
    IF txcor < 1 THEN txcor = 1
    IF tycor < 1 THEN tycor = 1
    IF txcor > brdwidth THEN txcor = brdwidth
    IF tycor > brdlength THEN tycor = brdlength
    IF NOT (build) THEN IF board(txcor, tycor) > 0 THEN CALL moveme(txcor, tycor, a$)
    xcor = txcor: ycor = tycor
    a = POINT(xcor * boxw + boxw / 2, ycor * boxl + boxl / 2)
    IF board(xcor, ycor) = 0 THEN CIRCLE (xcor * boxw + boxw / 2, ycor * boxl + boxl / 2), boxw / 3, 7
    CIRCLE (xcor * boxw + boxw / 2, ycor * boxl + boxl / 2), boxw / 3 - 2, 15

GOTO start

errorcontrol:
IF ERR = 53 THEN
    PRINT "File not found,opening default"
ELSE
    PRINT "unknown error: "; ERR
END IF
SLEEP
B$ = "empty"
RESUME

' add new levels here:

DATA "level1","level2","level3","level4","level5","end"

SUB addlist (xcor, ycor)
STATIC pointer
pointer = pointer + 1
endlist(pointer, 1) = xcor
endlist(pointer, 2) = ycor
IF xcor = -1 THEN pointer = 0
END SUB

SUB check
SHARED seconds, moved
SHARED c$
index = 1
runx = endlist(index, 1)
WHILE runx <> -1 AND runx <> 0
    runy = endlist(index, 2)
    IF board(runx, runy) <> 2 THEN
        LOCATE 23, 60: PRINT "Incomplete"; runx; runy
        GOTO jump
    END IF
    index = index + 1
    runx = endlist(index, 1)
WEND
LOCATE 22, 55: PRINT "Congradulations!   "
LOCATE 23, 55: PRINT "time: "; seconds; " seconds"
LOCATE 24, 55: PRINT "pushed blocks: "; moved; " times"
seconds = 0

WHILE INKEY$ = "": WEND
READ c$
IF c$ = "end" THEN RESTORE: READ c$: PRINT c$
CALL initboard(c$)
jump:
END SUB

SUB initboard (a$)
SHARED build
SHARED B$, txcor, tycor, xcor, ycor
B$ = a$
IF B$ = "" THEN
s:
IF ERR = 53 THEN PRINT "Not found, retype"
FILES "*.brd"
WHILE B$ = "": INPUT B$: WEND
END IF
OPEN B$ + ".brd" FOR INPUT AS #1
IF B$ = "empty" THEN build = -1 'ELSE build = 0
INPUT #1, txcor, tycor
FOR runx = 1 TO brdwidth
    FOR runy = 1 TO brdlength
        INPUT #1, inputed
        IF inputed = 3 THEN
            CALL addlist(runx, runy)
            board(runx, runy) = 0
        ELSE
            board(runx, runy) = inputed
        END IF
    NEXT
    INPUT #1, x
NEXT
CLOSE #1
CLS
CALL optionmenu
xcor = txcor: ycor = tycor

CALL showboard2'(1, 1, brdwidth, brdlength)
CALL addlist(-1, -1)
refresh
LOCATE 20, winwidth / 8 + 4: PRINT "Level name:  "; a$
CIRCLE (xcor * boxw + boxw / 2, ycor * boxl + boxl / 2), boxw / 3, 7
CIRCLE (xcor * boxw + boxw / 2, ycor * boxl + boxl / 2), boxw / 3 - 2, 15
END SUB

SUB moveme (x, y, a$)
SHARED tycor, txcor
SHARED moved
SELECT CASE a$

    CASE CHR$(0) + "M": tx = 1: ty = 0
    CASE CHR$(0) + "K": tx = -1: ty = 0
    CASE CHR$(0) + "P": tx = 0: ty = 1
    CASE CHR$(0) + "H": tx = 0: ty = -1
END SELECT
    IF board(x + tx, y + ty) = 0 AND board(x, y) <> 1 AND x > 1 AND y > 1 AND x < brdwidth AND y < brdlength THEN
        board(x + tx, y + ty) = board(x, y)
        board(x, y) = 0
        CALL showboard((x), (y), x + tx, y + ty)
        refresh
        moved = moved + 1
    ELSE
        tycor = tycor - ty
        txcor = txcor - tx
    END IF
END SUB

SUB optionmenu
LOCATE 2, winwidth / 8 + 4: PRINT "OPTIONS:"
LOCATE 4, winwidth / 8 + 4: PRINT " Game mode:"
LOCATE 5, winwidth / 8 + 4: PRINT "   arrow keys - move cursor"
LOCATE 6, winwidth / 8 + 4: PRINT "   r - Restart level"
LOCATE 7, winwidth / 8 + 4: PRINT "   l - Load level"
LOCATE 8, winwidth / 8 + 4: PRINT "   space - finish level:"
LOCATE 9, winwidth / 8 + 4: PRINT "   e - end game, quit"
LOCATE 10, winwidth / 8 + 4: PRINT "   alt+1,5,6 - Build mode"
LOCATE 12, winwidth / 8 + 4: PRINT " Build mode:"
LOCATE 13, winwidth / 8 + 4: PRINT "   space - put/change block"
LOCATE 14, winwidth / 8 + 4: PRINT "   s - save level"
LOCATE 15, winwidth / 8 + 4: PRINT "   l - load level"
LOCATE 16, winwidth / 8 + 4: PRINT "   n - jump to next level"
LOCATE 17, winwidth / 8 + 4: PRINT "   alt+1,5,6 - Game mode"




END SUB

SUB refresh
index = 1
runx = endlist(index, 1)
WHILE runx <> -1 AND runx <> 0
    runy = endlist(index, 2)
    CIRCLE (runx * boxw + boxw / 2, runy * boxl + boxl / 2), boxw / 3 + 1, 10
    CIRCLE (runx * boxw + boxw / 2, runy * boxl + boxl / 2), boxw / 3, 2
    CIRCLE (runx * boxw + boxw / 2, runy * boxl + boxl / 2), boxw / 3 - 2, 2
    LINE (runx * boxw + 1, runy * boxl + 1)-((runx + 1) * boxw - 1, (runy + 1) * boxl - 1), 2
    LINE ((runx + 1) * boxw - 1, runy * boxl + 1)-(runx * boxw + 1, (runy + 1) * boxl - 1), 2
    index = index + 1
    runx = endlist(index, 1)
WEND
END SUB

SUB saveboard (a$)
SHARED xcor, ycor
LOCATE 21, winwidth / 8 + 4
IF a$ = "" THEN INPUT "Type name of map:", a$
OPEN a$ + ".brd" FOR OUTPUT AS #1

index = 1
runx = endlist(index, 1)
WHILE runx <> -1 AND runx <> 0
    runy = endlist(index, 2)
    board(runx, runy) = 3
    index = index + 1
    runx = endlist(index, 1)
WEND


PRINT #1, xcor, ycor
FOR runx = 1 TO brdwidth
    FOR runy = 1 TO brdlength
        IF runx = 1 OR runy = 1 OR runx = brdwidth OR runy = brdlength THEN
            PRINT #1, 1
        ELSE
            PRINT #1, board(runx, runy)
        END IF
    NEXT
    PRINT #1,

NEXT
CLOSE #1
END SUB

SUB showboard (startx, starty, endx, endy)

IF startx > endx THEN temp = startx: startx = endx: endx = temp
IF starty > endy THEN temp = starty: starty = endy: endy = temp

FOR runx = startx - 1 TO endx
    FOR runy = starty - 1 TO endy
       
        IF runx >= startx AND runy >= starty THEN
            LINE (runx * boxw + 1, runy * boxl + 1)-((runx + 1) * boxw - 1, (runy + 1) * boxl - 1), board(runx, runy), BF
            LINE (runx * boxw + 3, runy * boxl + 3)-((runx + 1) * boxw - 3, (runy + 1) * boxl - 3), board(runx, runy) - 8 * (board(runx, runy) <> 0), B
            LINE (runx * boxw + 2, runy * boxl + 2)-(runx * boxw + 2, (runy + 1) * boxl - 2), -15 * (board(runx, runy) <> 0)
            LINE (runx * boxw + 2, runy * boxl + 2)-((runx + 1) * boxw - 2, runy * boxl + 2), -15 * (board(runx, runy) <> 0)
            LINE ((runx + 1) * boxw - 2, runy * boxl + 2)-((runx + 1) * boxw - 2, (runy + 1) * boxl - 2), 0
            LINE (runx * boxw + 2, (runy + 1) * boxl - 2)-((runx + 1) * boxw - 2, (runy + 1) * boxl - 2), 0
        END IF

IF iamanalien THEN
        PSET ((runx + 1) * boxw, (runy + 1) * boxl), 15
        IF board(runx, runy) <> board(runx + 1, runy) THEN
            LINE ((runx + 1) * boxw, runy * boxl)-((runx + 1) * boxw, (runy + 1) * boxl), 15
        ELSE
            LINE ((runx + 1) * boxw, runy * boxl + 1)-((runx + 1) * boxw, (runy + 1) * boxl - 1), 7
        END IF
  
        IF board(runx, runy) <> board(runx, runy + 1) THEN
            LINE (runx * boxw, (runy + 1) * boxl)-((runx + 1) * boxw, (runy + 1) * boxl), 15
        ELSE
            LINE (runx * boxw + 1, (runy + 1) * boxl)-((runx + 1) * boxw - 1, (runy + 1) * boxl), 7
        END IF
END IF
    NEXT
NEXT

END SUB

SUB showboard2



FOR linenum = brdwidth TO 1 STEP -1
    FOR runx = brdwidth + 1 - linenum TO linenum
        CALL showboard(runx, linenum + 1, runx, linenum + 1)
    NEXT
    FOR runy = brdlength - linenum TO linenum
        CALL showboard(brdwidth + 1 - linenum, runy, brdwidth + 1 - linenum, runy)
    NEXT
    FOR runx = linenum TO brdwidth - linenum STEP -1
        CALL showboard(runx, brdwidth - linenum, runx, brdwidth - linenum)
    NEXT
    FOR runy = linenum TO brdlength - linenum STEP -1
        CALL showboard(linenum, runy, linenum, runy)
    NEXT
NEXT
    


END SUB

